'use strict';
const {
  Model
} = require('sequelize');
module.exports = (sequelize, DataTypes) => {
  class user_answers extends Model {
    static associate(models) {
      user_answers.belongsTo(models.user,{
        foreignKey:'user_id',
        onDelete:'cascade'
      });
      user_answers.belongsTo(models.quiz,{
        foreignKey:'quiz_id',
        onDelete:'cascade'
      });
      user_answers.belongsTo(models.question,{
        foreignKey:'question_id',
        onDelete:'cascade'
      });
      user_answers.belongsTo(models.option, {
        foreignKey: 'answer',
        as: 'selectedOption',
        onDelete: 'cascade',
      });
    }
  }
  user_answers.init({
    user_id:{
      type:DataTypes.INTEGER,
      allowNull:false
    },
    quiz_id:{
      type:DataTypes.INTEGER,
      allowNull:false
    },
    question_id:{
      type:DataTypes.INTEGER,
      allowNull:false
    },
    answer:{
      type:DataTypes.INTEGER,
      allowNull:false
    },
    is_correct:{
      type:DataTypes.BOOLEAN,
      allowNull:false,
      defaultValue:false
    }
  }, {
    sequelize,
    modelName: 'user_answers',
    tableName:'user_answers'
  });
  return user_answers;
};